/**
 * ClearDialog.java
 * <P>
 * @author <A HREF="http://www.cs.cmu.edu/~fgcozman/home.html">Fabio Cozman</A>
 * Copyright 1996, Fabio Cozman <BR>
 * Date: February 23 1997 <BR>
 * <P>
 * The BayesianNetworks package is free software; you can
 * redistribute it and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation, provided
 * that this notice and the name of the author appear in all copies.
 * If you're using the software, please notify fgcozman@cs.cmu.edu so
 * that you can receive updates and patches.
 * The BayesianNetworks package is distributed "as is", in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with the BayesianNetworks package. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package JavaBayesInterface;

import JavaBayes;

import java.awt.*;

public class ClearDialog extends Dialog {
    JavaBayes jb;

	public ClearDialog(Frame parent, JavaBayes java_bayes,
	                   String title, boolean modal) {
	    super(parent, title, 
                  false); // modal); Bug in JDK1.1.6 does not accept modal.
	    jb = java_bayes;

		//{{INIT_CONTROLS
		setLayout(new FlowLayout(FlowLayout.CENTER,20,20));
		addNotify();
		resize(insets().left + insets().right + 295,insets().top + insets().bottom + 92);
		yesButton = new java.awt.Button("Yes");
		yesButton.reshape(insets().left + 51,insets().top + 20,60,40);
		add(yesButton);
		noButton = new java.awt.Button("No");
		noButton.reshape(insets().left + 165,insets().top + 20,60,40);
		add(noButton);
		setResizable(false);
		//}}

	}

    public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

	public boolean handleEvent(Event event) {
		if (event.target == noButton && event.id == Event.ACTION_EVENT) {
		    dispose();
		}
		if (event.target == yesButton && event.id == Event.ACTION_EVENT) {
            jb.clear();
            dispose();
		}
		return super.handleEvent(event);
	}

	//{{DECLARE_CONTROLS
	java.awt.Button yesButton;
	java.awt.Button noButton;
	//}}
}
