/**
 * OpenURLDialog.java
 * <P>
 * @author <A HREF="http://www.cs.cmu.edu/~fgcozman/home.html">Fabio Cozman</A>
 * Copyright 1996, Fabio Cozman <BR>
 * <P>
 * The BayesianNetworks package is free software; you can
 * redistribute it and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation, provided
 * that this notice and the name of the author appear in all copies.
 * If you're using the software, please notify fgcozman@cs.cmu.edu so
 * that you can receive updates and patches.
 * The BayesianNetworks package is distributed "as is", in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with the BayesianNetworks package. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package JavaBayesInterface;

import JavaBayes;

import java.awt.*;

public class OpenURLDialog extends Dialog {
    JavaBayes jb;

	void OkButton_Clicked(Event event) {
        jb.open_url(textURL.getText());
        dispose();
	}

	void CancelButton_Clicked(Event event) {
		dispose();
	}

	public OpenURLDialog(Frame parent, JavaBayes java_bayes, boolean modal) {
	    super(parent, false); // modal); Bug in JDK1.1.6 does not accept modal.

		//{{INIT_CONTROLS
		setLayout(new BorderLayout());
		addNotify();
		resize(insets().left + insets().right + 295,insets().top + insets().bottom + 92);

		textURL = new TextField();
		add("North", textURL);

		panelButtons = new Panel();
		panelButtons.setLayout(new FlowLayout(FlowLayout.CENTER,20,20));
		okButton = new java.awt.Button("Ok");
		panelButtons.add(okButton);
		cancelButton = new java.awt.Button("Cancel");
		panelButtons.add(cancelButton);
		add("South", panelButtons);

		setResizable(false);
		//}}

		// Insert the JavaBayes object
		jb = java_bayes;
	}

	public OpenURLDialog(Frame parent, JavaBayes java_bayes,
	                     String title, boolean modal) {
	    this(parent, java_bayes, modal);
	    setTitle(title);
	}

    public synchronized void show() {
    	Rectangle bounds = getParent().bounds();
    	Rectangle abounds = bounds();

    	move(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

	public boolean handleEvent(Event event) {
		if (event.target == cancelButton && event.id == Event.ACTION_EVENT) {
			CancelButton_Clicked(event);
		}
		if (event.target == okButton && event.id == Event.ACTION_EVENT) {
			OkButton_Clicked(event);
		}
		return super.handleEvent(event);
	}

	//{{DECLARE_CONTROLS
	java.awt.TextField textURL;
	java.awt.Panel panelButtons;
	java.awt.Button okButton;
	java.awt.Button cancelButton;
	//}}
}
