package learn;

/**
 * Contains a state of an agent
 * @author Coen Pieterse
 * @version 1.0
 */


public abstract class QState {

  /**
   * Override standard implementation to ensure this is implemented in any subclass
   */
  public boolean equals( Object o )
  {
	  if( o instanceof QState )
		  return equals( (QState)o );
	  return false;
  }

  /**
   * Check if 2 states are equal
   */  
  public abstract boolean equals( QState state );
  
  /**
   * If 2 states are equal their hashcode MUST be equal
   * (s1 equal s2) -> (h1 = h2)
   */  
  public abstract int hashCode();


}