package org.uva.gui;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import org.uva.object.Grid;
import org.uva.object.*;
import java.util.*;
import org.uva.sensorServer.*;

public class ControlGui extends JFrame implements ActionListener,
    ChangeListener
{
    private JComboBox gridType;
    private JTextField gridWidth, gridHeight,
           agentGroup;
    private JSlider speed;
    private JTextField speedField;

    private JToggleButton runButton;
    private JButton clear;

    public GridGui gridGui;
    public Grid grid;
    private GenerationHandler handler;

    private JTabbedPane tab;

    private SensorConnectorGUI sensorGUI = new SensorConnectorGUI();
    
    public Vector agentProperties;

    private SensorServer sensorServer;
    
    public ControlGui(GridGui gridGui, Grid grid)
    {
        super("ControlFrame");

        this.grid = grid;
        this.gridGui = gridGui;
        
        sensorServer = new SensorServer(true);
        Container container = this.getContentPane();
        container.setLayout(new BoxLayout(container, BoxLayout.Y_AXIS));

        JPanel p0 = new JPanel(new FlowLayout(FlowLayout.LEFT));
        container.add(p0);
        p0.add(new JLabel("GridType"));
        p0.add(gridType = new JComboBox(new String[] {"Toroid", "Flat"}));

        JPanel p6 = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        container.add(p6);
        p6.add(new JLabel("speed"));
        p6.add(speed = new JSlider(0, 1000));
        p6.add(speedField = new JTextField(3));
        speedField.setEditable(false);

        JPanel p2 = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        container.add(p2);
        p2.add(new JLabel("GridWidth"));
        p2.add(gridWidth = new JTextField(3));
        p2.add(new JLabel("GridHeight"));
        p2.add(gridHeight = new JTextField(3));

        JPanel p8 = new JPanel(new FlowLayout(FlowLayout.CENTER));
        container.add(p8);
        p8.add(new JLabel("NrOfAgentGroup"));
        p8.add(agentGroup = new JTextField(3));

        container.add(tab = new JTabbedPane());

        JPanel p7 = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        container.add(p7);
        p7.add(clear = new JButton("Clear"));
        p7.add(runButton = new JToggleButton("Start"));

        startVariables();

        runButton.addActionListener(this);
        clear.addActionListener(this);
        gridWidth.addActionListener(this);
        gridHeight.addActionListener(this);
        speed.addChangeListener(this);
        gridType.addActionListener(this);
        agentGroup.addActionListener(this);

        setVariables(true);

		for( int i = 0;i < SensorConnectorGUI.NUMBER_OF_SENSORS; i++  )
		{
	        SensorPollerThread sensorThread = new SensorPollerThread( i );
	        sensorThread.start();
		}
        
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.pack();
        this.setVisible(true);
    }

    public void actionPerformed(ActionEvent e)
    {
        if(e.getSource()==runButton)
        {
            if(runButton.isSelected())
            {
                startGeneration();
            }
            else
            {
                stopGeneration();
            }
        }
        else if(e.getSource()==gridWidth||
                e.getSource()==gridHeight)
        {
            stopGeneration();
            grid.initGrid(this.getGridWidth(), this.getGridHeight(), agentProperties);
            gridGui.setGrid(grid);
        }
        else if(e.getSource()==clear)
        {
            stopGeneration();
            try
            {
                Thread.sleep(100);
            }
            catch(Exception ee){}

            for(int x = 0; x<agentProperties.size(); x++)
            {
                AgentProperties p = (AgentProperties)agentProperties.get(x);
                System.out.println(p);
            }
            System.out.println("---------");

            // connect first property to sensors
            if( agentProperties.size() > 0 )
            	sensorGUI.setProperties( (AgentProperties)agentProperties.get(0) );
            
            grid.initGrid(this.getGridWidth(), this.getGridHeight(), agentProperties);
            gridGui.setGrid(grid);
        }
        if(e.getSource()==gridType)
        {
            setVariables(false);
        }
        else if(e.getSource()==agentGroup)
        {
            stopGeneration();
            setVariables(true);
            grid.initGrid(this.getGridWidth(), this.getGridHeight(), agentProperties);
            gridGui.setGrid(grid);
        }
    }

    public void stateChanged(ChangeEvent e)
    {
        if(e.getSource()==speed)
        {
            if(handler!=null)
                handler.setTimer(speed.getMaximum()-speed.getValue());
            setVariables(false);
        }
    }

    private void setVariables(boolean setGroup)
    {
        if(gridType.getSelectedIndex()==0)
            grid.setFlat( false );
        else
            grid.setFlat( true );
        speedField.setText(speed.getMaximum()-speed.getValue()+"");
        if(setGroup)
            setGroup();
    }
    
    protected void newSensorValue( int sensor, int value ){
    	this.sensorGUI.setSensorValue( sensor, value );
    }
    
    
    

    private void setGroup()
    {
        int group = 1;
        try
        {
            group = Integer.parseInt(agentGroup.getText());
        }
        catch(Exception e){}

        tab.removeAll();
        agentProperties = new Vector();
        for(int x = 0; x<group; x++)
        {
            Color col = new Color((int)(Math.random()*255),
                                  (int)(Math.random()*255),
                                  (int)(Math.random()*255));

            AgentProperties p = new AgentProperties(col);
            agentProperties.add(p);
            tab.add(x+"",new AgentControlGui(p, this));
        }
        // connect first property to sensors
        if( agentProperties.size() > 0 )
        	sensorGUI.setProperties( (AgentProperties)agentProperties.get(0) );

        grid.agentProperties = agentProperties;
        this.pack();
    }

    private void startGeneration()
    {
        setVariables(false);
//        grid.initGrid(this.getGridWidth(), this.getGridHeight(), agentProperties);
        runButton.setSelected(true);
        handler = new GenerationHandler(gridGui, grid);
        handler.setTimer(speed.getMaximum()-speed.getValue());
        sensorGUI.setGenerationHandler( handler );
        
        handler.start();
        runButton.setText("Stop");

    }

    public void stopGeneration()
    {
        runButton.setSelected(false);
        if(handler!=null)
            handler.setRunning(false);
        handler = null;
        runButton.setText("Start");

    }

    private void startVariables()
    {
        gridType.setSelectedIndex(0);

        gridWidth.setText("50");
        gridHeight.setText("50");
        speed.setValue(490);
        agentGroup.setText(1+"");
    }

    public int getGridWidth()
    {
        try
        {
            return Integer.parseInt(gridWidth.getText());
        }
        catch(Exception e)
        {
            gridWidth.setText("Err");
        }
        return 0;
    }

    public int getGridHeight()
    {
        try
        {
            return Integer.parseInt(gridHeight.getText());
        }
        catch(Exception e)
        {
            gridWidth.setText("Wrong number format");
        }
        return 0;
    }
    
    private class SensorPollerThread extends Thread{
    	
    	int sensor;
    	
    	SensorPollerThread( int sensor ){
    		this.sensor = sensor;
    	}
    	
    	public void run(){
    		while(true){
				try{
	       			 int value = ControlGui.this.sensorServer.getSensorData( sensor );
	    			 newSensorValue( sensor, value );
					Thread.sleep(500);
				}catch(Exception e){}
    		}
    	}
    }

}
