package org.uva.object;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */

import java.awt.*;
import java.util.*;

public class Grid
{
    private GridElement[][] grid;

    public Vector agentProperties;

    private Hashtable agents;
    private int agentCounter = 0;
    protected boolean flat;

    public Grid()
    {
    }

    public void initGridOld(int width, int height, Vector agentProperties)
    {
        this.agentProperties = agentProperties;
        agentCounter = 0;
        agents = new Hashtable();
        grid = new GridElement[width][height];
        for(int x = 0; x<width; x++)
            for(int y = 0; y<height; y++)
            {
                grid[x][y] = new GridElement();
            }
        boolean randColor = false;
        if(agentProperties.size()==1)
            randColor = true;
        for(int x =0; x<agentProperties.size(); x++)
        {
            AgentProperties p = (AgentProperties)agentProperties.get(x);
            System.out.println(p.agentCount);
            for(int y = 0; y<p.agentCount; y++)
            {
                int x1 = (int)(Math.random()*width);
                int y1 = (int)(Math.random()*height);
                if(randColor)
                {
                    Color col = new Color((int)(Math.random()*255),
                                          (int)(Math.random()*255),
                                          (int)(Math.random()*255));
                    addAgent(x1, y1, col, x);
                }
                else
                    addAgent(x1, y1, p.color, x);
            }
        }

    }
    
    /**
     * Remove all agents
     *
     */
    public void clearGrid()
    {
    	if( agents == null )
    		return;
    	Object[] allAgents = agents.values().toArray();
    	for( int i = 0 ; i < allAgents.length; i++ )
    		((Agent)allAgents[i]).die();
    	agents.clear();
    }
    
    public void initGrid(int width, int height, Vector agentProperties )
    {
    	clearGrid();
        this.agentProperties = agentProperties;
        agentCounter = 0;
        agents = new Hashtable();
        grid = new GridElement[width][height];
        for(int x = 0; x<width; x++)
            for(int y = 0; y<height; y++)
            {
                grid[x][y] = new GridElement();
            }
        boolean randColor = false;
        if(agentProperties.size()==1)
            randColor = true;
        for(int x =0; x<agentProperties.size(); x++)
        {
            AgentProperties p = (AgentProperties)agentProperties.get(x);
            System.out.println(p.agentCount);
            for(int y = 0; y<p.agentCount; y++)
            {
                int x1 = (int)(Math.random()*width);
                int y1 = (int)(Math.random()*height);
                if( p.predatorPrey )
                {
	            	addPPAgent(x1, y1, x);
                }
                else if(randColor)
                {
                    Color col = new Color((int)(Math.random()*255),
                                          (int)(Math.random()*255),
                                          (int)(Math.random()*255));
                	addAgent(x1, y1, col, x);
                }
                else
	            	addAgent(x1, y1, p.color, x);
            }
        }
        //cycleGrid();
    }


    /**
     * Flat means solid walls
     * @return
     */
    public boolean isFlat()
    {
    	return this.flat;
    }
    
    /**
     * Flat means solid walls
     * @param flat
     */
    public void setFlat( boolean flat )
    {
    	this.flat = flat;
    }

    
    public GridElement[][] getGrid()
    {
        return grid;
    }

    /**
     * Add an agent at a random location
     * @param c
     * @param group
     */
    public void addAgentRandomly( Color c, int group )
    {
    	int x =(int)( Math.random() * grid.length );
    	int y =(int)( Math.random() * grid[0].length );
    	addAgent( x, y, c, group );
    }

    /**
     * Add an agent at a random location
     * @param c
     * @param group
     */
    public Point getRandomPosition( )
    {
    	int x =(int) (Math.random() * grid.length);
    	int y =(int) (Math.random() * grid[0].length);
    	return new Point(x,y);
    }

    
    public void addAgent(int x, int y, Color c, int group)
    {
        grid[x][y] = new GridElement(agentCounter,group, c);
        agents.put(new Integer(agentCounter), new Agent(agentCounter,group, c, new Point(x, y), this));
        agentCounter++;
    }
   
    public void addPPAgent(int x, int y, int group)
    {
        int type;
        Color color;
        if( Math.random() < 0.8 )
        {
        	type = PredatorPreyAgent.TYPE_PREY;
        	color = Color.PINK;
        }
        else
        {
        	type = PredatorPreyAgent.TYPE_PREDATOR;
        	color = Color.RED;
        }
        addPPAgent(x,y, color, group, type );
    }

    public void addPPAgent(int x, int y, Color color, int group, int type)
    {
        grid[x][y] = new GridElement(agentCounter,group, color);
        
        PredatorPreyAgent agent = new PredatorPreyAgent(agentCounter, group, color, new Point(x, y), this, type );
        agents.put(new Integer(agentCounter), agent );
        agentCounter++;
    }

    /**
     * Show all agents
     *
     */
    protected void updateGrid()
    {
        for(int x = 0; x<grid.length; x++)
            for(int y = 0; y<grid[x].length; y++)
            {
                GridElement e = grid[x][y];
                try
                {
                    /*AgentProperties p = (AgentProperties) agentProperties.get(
                            e.group);
                    // update trail
                    if (e.getAgentId() != -1 &&
                        e.getTrailCount() < p.trailLength - 1) {
                        e.setTrailCount(e.getTrailCount() + 1);
                    } else if (e.getAgentId() != -1) {
                        grid[x][y] = new GridElement();
                    }*/
                    if(e.getAgentId() != -1)
                    {
	                     // update trail
	                	 int trailCount = e.getTrailCount(); 
	                	 if( trailCount > 1 )
	                		 e.setTrailCount( trailCount - 1 );
	                	 else if( trailCount <= 1 )
	                		 grid[x][y] = new GridElement();
               	 }
                }
                catch(Exception we){}
            }

    }
    
    
    public synchronized void nextGeneration()
    {
    	updateGrid();
         //System.out.println( "Agents: " + agents.size() );
         // update agents
         Enumeration en = agents.keys();
         while(en.hasMoreElements())
         {
             Integer i = (Integer)en.nextElement();
             Agent a = (Agent)agents.get(i);
             AgentProperties p = (AgentProperties)agentProperties.get(a.group);
             a.nextPosition(flat, agents, grid, p);
         }

         // update agents
         en = agents.keys();
         while(en.hasMoreElements())
         {
             Integer agentID = (Integer)en.nextElement();
             Agent a = (Agent)agents.get(agentID);
             // agent died
             if(a.isDead())
             {
                 agents.remove(agentID);
                 grid[a.curPosition.x][a.curPosition.y] = new GridElement();
             }
             else
             {
            	 if( a.nextPosition != null )
            	 {
                     AgentProperties p = (AgentProperties)agentProperties.get(a.group);
            		 boolean setElement = false;
                     GridElement element = grid[a.nextPosition.x][a.nextPosition.y];
            		 if( element.getAgentId() == -1 )
            		 {
            			 setElement = true;
            		 }
            		 else
            		 {
            			 if( element.getTrailCount() < p.trailLength ){
            				 setElement = true;
            			 }
            		 }
            		 if( setElement )
            		 {
    	                 grid[a.nextPosition.x][a.nextPosition.y] 
    	                           = new GridElement(agentID.intValue()
    	                        		   , a.group 
    	                                   , a.color);
    	                 grid[a.nextPosition.x][a.nextPosition.y].setTrailCount( p.trailLength );
            		 }

            		
            	 }
                 a.updatePosition();
             }
         }

    }
    
}
