package org.uva.object;

/**
 * represents a element in the 2D grid
 * When the element is empty, then agentId equals -1
 * Most important variables are: agentId and group
 */

import java.awt.*;

public class GridElement
{
    private int agentId, trailCount;
    private Color color;
    public int group; // the group an agent belongs to

    public GridElement(int agentId, int group, Color color)
    {
        this(agentId,group,  color, 0);
    }

    public GridElement()
    {
        this(-1, -1, Color.WHITE, 0);
    }

    public  GridElement(int agentId, int group, Color color, int trailCount)
    {
        this.agentId = agentId;
        this.color = color;
        this.group = group;
        this.trailCount = trailCount;
    }

    public int getAgentId(){return agentId;}
    public Color getColor(){return color;}
    public int getTrailCount(){return trailCount;}

    public void setAgentId(int id){this.agentId = id;}
    public void setColor(Color color){this.color = color;}
    public void setTrailCount(int count){this.trailCount = count;}
}
