package org.uva.sensorServer;


import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

/**
 * <p>
 * <b>NOTES:</b><br>
 * <ul>
 * <li>Version Mar 9, 2005 ( Created ) </li>
 * </ul>
 * 
 * @author James Caska
 * @see 
 */
public class SensorMap {
	Vector  	mySensors 	= new Vector();
	Hashtable	myLookup 	= new Hashtable ();
	
	public SensorMap(){
		addSensor(new SensorDescription(1, "127.0.0.1","83",	"10.1.1.7",	"ISimSensor","sim" ));
		addSensor(new SensorDescription(2, "127.0.0.1","84",	"10.1.1.7",	"ISimSensor","sim" ));
		addSensor(new SensorDescription(3, "127.0.0.1","101", "10.1.1.10", "IUvmSensor","uvm"));
	}
	
	public Vector getSensors(){
		return mySensors;
	}
	
	public SensorDescription getSensor (int sensorId) {
		return (SensorDescription) myLookup.get("S"+sensorId);
	}
	
	// Please note that this function activates sensors.
	// Deactivation is not done anywhere currently
	public void activateSensors(String gatewayIp, String gatewayPort) {  
		for (Enumeration e = mySensors.elements() ; e.hasMoreElements() ;) {
			SensorDescription sensor = (SensorDescription) e.nextElement();      
			if (sensor.matchGateway(gatewayIp,gatewayPort ))
				sensor.setActive(true);
		}      
	}
	
	public static String getKey(String gatewayIp, String gatewayPort, String deviceIp){
		return gatewayIp + gatewayPort + deviceIp;
	}
	
	public Vector getGatewaySensors( String gatewayIp, String gatewayPort ){
		Vector sensors = new Vector();     
		for (Enumeration e = mySensors.elements() ; e.hasMoreElements() ;) {
			SensorDescription sensor = (SensorDescription) e.nextElement();      
			if( sensor.matchGateway(gatewayIp,gatewayPort )){
				sensors.add( sensor );
			}
		}      
		return sensors;
	}
	
	public void addSensor(SensorDescription sensor){
		mySensors.add(sensor);
		myLookup.put(sensor.key(), sensor);
	}
}
