/*
 * @(#)GenericSensorSimImpl.java Created on Mar 9, 2005
 *
 * Copyright 2003 to 2005 James Caska, muvium.com . All Rights Reserved
 */

package ws.impls;

import ws.interfaces.IGenericSensor;
import ws.proxyImpls.IGenericSensorProxy;
/**
 * The GenericSensorSimImpl implements the IGenericSensor but when invoked it
 * looks up it's value from the simulator via a WebService call
 * 
 * The SensorId
 * 
 * <p>
 * <b>NOTES:</b><br>
 * <ul>
 * <li>Version Mar 9, 2005 ( Created ) </li>
 * </ul>
 * 
 * @author James Caska
 * @see 
 */
public class GenericSensorSimImpl  implements IGenericSensor {

    IGenericSensorProxy mySimulatorProxy;
    int 			mySensorId;
    
    public GenericSensorSimImpl( 	int		sensorId,
            					String 	simulatorProxy, 
            					String 	simulatorPort,
            					String  simulatorIp ){
            					
        
        mySimulatorProxy 	= new IGenericSensorProxy( simulatorProxy + ":" + simulatorPort + "/http://" + simulatorIp );
        mySensorId			= sensorId;
    }
    
    public int getSensorValue(int sensorId){
        return mySimulatorProxy.getSensorValue(mySensorId);
     }
   
    public int setSensorValue(int sensorId, String subSensor, String measure, String value){
        return mySimulatorProxy.setSensorValue(sensorId, subSensor, measure, value);
     }
     
   public String 	getName( String name ){
        return name + " - Remote Sensor Id = "  + String.valueOf( mySensorId );
    }
    
    public String getStringIntParam( String name, int param ){
        return name + " Sensor Id = " + String.valueOf( mySensorId )+ " param = " + String.valueOf( param );
    }
    
}
