/*
 * @(#)GenericSensorSimImpl.java Created on Mar 9, 2005
 *
 * Copyright 2003 to 2005 James Caska, muvium.com . All Rights Reserved
 */

package ws.impls;
import ws.interfaces.IMotionDetector;
import ws.proxyImpls.IMotionDetectorProxy;

/**
 * The GenericSensorSimImpl implements the IGenericSensor but when invoked it
 * looks up it's value from the simulator via a WebService call
 * 
 * The SensorId
 * 
 * <p>
 * <b>NOTES:</b><br>
 * <ul>
 * <li>Version Mar 9, 2005 ( Created ) </li>
 * </ul>
 * 
 * @author James Caska
 * @see 
 */
public class MotionSensorSimImpl  implements IMotionDetector  {

    IMotionDetectorProxy 	mySimulatorProxy;
    int 					mySensorId;
    
    public MotionSensorSimImpl( 	int		sensorId,
            						String 	simulatorProxy, 
            						String 	simulatorPort,
            						String  simulatorIp ){
            					
        
        mySimulatorProxy 	= new IMotionDetectorProxy( simulatorProxy + ":" + simulatorPort + "/http://" + simulatorIp );
        mySensorId			= sensorId;
    }
    
    public int getMotionValue(int sensorId){
         return mySimulatorProxy.getMotionValue(mySensorId);
    }
  
}
