/*
 * @(#)IGenericSensor.java Created on Mar 9, 2005
 *
 * Copyright 2003 to 2005 James Caska, muvium.com . All Rights Reserved
 */

package ws.interfaces;

import com.muvium.web.WSDL;

/**
 * <p>
 * <b>NOTES:</b><br>
 * <ul>
 * <li>Version Mar 9, 2005 ( Created ) </li>
 * </ul>
 * 
 * This implementation makes sure that all gas sensor functions may be called
 * We have the folllowing facilities
 *   - AN4 - Power monitor 4.8v
 *   - AN5 - Power monitor 9v
 *   - AN6 - AC output (High gain)
 *   - AN7 - DC output (Sensor out)
 *     DI1 - FET Sensor on
 *     DI2 - Sensor pin 1 - SCK
 *     DI3 - Sensor pin 4 - Tristate Data

 * - getSensorValue will retrieve the value of the main sensor or a subsensor
 * 					7 = Main sensor
 * 					  = High Gain sensor
 * 					  = Power 4.8v
 * 					6 = Poswer 9v
 * 					  = Temperature
 * 					  = Humidity
 * 
 * - getState returns the current state of the sensor
 * - setState sets the state of the sensor. 
 *   On the real sensor this also mey be done using the DIP switches
 *   We have the following states:
 *   				0 = Off/Idle
 *   				1 = Sensor on / real mode
 *   				2 = Simulation mode
 *   				3 = Loopback mode
 * 
 * @author Peter van Lith
*/
public interface IGasSensorUvm extends WSDL{
    
    public int 	getSensorValue(int sensor);
	public void setSensorLevel(int level, int value);
	public int 	getState();
	public void setState(int dip);	
}
