package ws.test;


import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

/**
 * <p>
 * <b>NOTES:</b><br>
 * <ul>
 * <li>Version Mar 9, 2005 ( Created ) </li>
 * </ul>
 * 
 * @author James Caska
 * @see 
 */
public class SensorMap {
    Vector  	mySensors 	= new Vector();
    Hashtable	myLookup 	= new Hashtable ();

/**
 * 
 * The simulator (when used) defines the test sensor as follows:
 * 
 *   <Sensor id="GS1" name="Gassensor" type="Gas" location="N 06 30 05 E 80 01 20" orientation="-1"
 *		sensorID="7" gatewayIP="127.0.0.1" devicePort="83" deviceIP="10.1.1.8" serviceType="sim"/>
 *	 <Sensor id="GS-UVM" name="Gassensor" type="Gas" location="N 06 30 55 E 80 01 50" orientation="-1"
 *		sensorID="8" gatewayIP="127.0.0.1" devicePort="101" deviceIP="10.1.1.10" serviceType="uvm"/>    
 */
  
    public Vector getSensors(){
        return mySensors;
    }
    
	public static String getKey(String gatewayIp, String gatewayPort, String deviceIp){
	    return gatewayIp + gatewayPort + deviceIp;
	}
	
    public Vector getGatewaySensors( String gatewayIp, String gatewayPort ){
        Vector sensors = new Vector();     
        for (Enumeration e = mySensors.elements() ; e.hasMoreElements() ;) {
            SensorServiceDescription sensor = (SensorServiceDescription) e.nextElement();      
            if( sensor.matchGateway(gatewayIp,gatewayPort )){
                sensors.add( sensor );
            }
        }      
        return sensors;
    }
    
    public void addSensor(SensorServiceDescription sensor){
        mySensors.add( sensor );
        myLookup.put( sensor.key(), sensor );
    }
}
