package ws.test;


import java.util.Enumeration;
import java.util.Hashtable;

import ws.interfaces.*;
import ws.proxyImpls.*;

/**
 * The similator is used to both represent and retrive data for certain scenarios
 * 
 * <p>
 * <b>NOTES:</b><br>
 * <ul>
 * <li>Version Mar 9, 2005 ( Created ) </li>
 * </ul>
 * 
 * @author James Caska
 * @see 
 */
public class Simulator extends Thread implements IGenericSensor, IMotionDetector{
    private int[] SCENARIO_DISASTER = new int[]{10,20,30,40,50,60};
    private int[] currentScenario = SCENARIO_DISASTER;
    private	SensorMap mySensorMap;
    
    Hashtable sensorValues = new Hashtable();
    
    public Simulator(SensorMap sensorMap){
        mySensorMap = sensorMap;
    }
       
    /**
     * Access the Sensor data
     */
    public int getSensorValue(int sensorId){
    	Integer key = new Integer(sensorId);
    	if( sensorValues.containsKey( key ) )
    	{
    		return ((Integer)sensorValues.get( key )).intValue();
    	}
    	else
    	{
    		int value = (int)(Math.random() * 100);
    		System.out.println( "New key:" + key );
    		sensorValues.put( key, new Integer(value) );
    		return value;
    	}    	
    }
    
    public int setSensorValue(int i, String s1, String s2, String s3) {
    	return 0;
    }
    
    public void setSensorValue( int sensorID, int value ) {
    	Integer key = new Integer(sensorID);
		sensorValues.put( key, new Integer(value) );
    }

    
    public String getName (String s1) {
    	return "aSensor";
    }
    
   public int getMotionValue(int sensorId){ 
        if( sensorId >=0 && sensorId < currentScenario.length ){
            System.out.print( " MOT("  + String.valueOf( sensorId ) + ")=" + String.valueOf( currentScenario[ sensorId ] ) + " " );
            return currentScenario[ sensorId ];
        }else{
            System.out.print( " MOT(?)=? ");
            return -1;
        }
    }
    
    public void run(){   
        while( true ){        
            try{
                Thread.sleep(1000);
            }catch(Exception e){}
            
        	for (Enumeration e = mySensorMap.getSensors().elements(); e
					.hasMoreElements();) {
        		try
        		{
					SensorServiceDescription sensor = (SensorServiceDescription) e.nextElement();
					Object sensorProxy = sensor.getProxy();				
					if (sensorProxy instanceof IGenericSensorProxy) {
						System.out.print( "Getting Simulated Gas Sensor:" +
								sensor.myDeviceIp + ":" + sensor.myGatewayPort+ " (" +
								sensor.myId + ")");
						System.out.println(((IGenericSensorProxy) sensorProxy).getSensorValue(0));
					}
					else if (sensorProxy instanceof IMotionDetectorProxy) {
						System.out.print( "Getting Motion Detector:" +
								sensor.myDeviceIp + ":" + sensor.myGatewayPort+ " (" +
								sensor.myId + ")");
						System.out.println(((IMotionDetectorProxy) sensorProxy).getMotionValue(0));
					}
					else if (sensorProxy instanceof IGasSensorUvmProxy) {
						System.out.print( "Getting Uvm Gas Sensor:" +
								sensor.myDeviceIp + ":" + sensor.myGatewayPort+ " (" +
								sensor.myId + ")");
						int value = ((IGasSensorUvmProxy) sensorProxy).getSensorValue(0);
						System.out.println( value );
						value = (int)((1.5 - Math.random())*value);
						((IGasSensorUvmProxy) sensorProxy).setSensorValue( 0, value );
						//((IGasSensorUvmProxy) sensorProxy).setSensorLevel( 0, value );
					}
					else {
						System.out.println("Unknown Sensor:" + sensor.myDeviceIp
						   + ":" + sensor.myGatewayPort + " (" + sensor.myId + ")");
					}
					Thread.sleep( 100 );
        		} catch( Exception exc ){
        			
        		}
			}
		}
	}
}
